/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.eclipse.sphinx.examples.hummingbird20.workflows.dump;

import com.google.common.base.Objects;
import java.util.List;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.mwe.core.WorkflowContext;
import org.eclipse.emf.mwe.core.issues.Issues;
import org.eclipse.emf.mwe.core.monitor.ProgressMonitor;
import org.eclipse.sphinx.emf.mwe.dynamic.IWorkflowSlots;
import org.eclipse.sphinx.emf.mwe.dynamic.components.AbstractModelWorkflowComponent;
import org.eclipse.sphinx.examples.hummingbird20.common.Identifiable;
import org.eclipse.xtext.xbase.lib.InputOutput;

@SuppressWarnings("all")
public class DumpHummingbird20WorkflowComponent extends AbstractModelWorkflowComponent {
  protected void invokeInternal(final WorkflowContext ctx, final ProgressMonitor monitor, final Issues issues) {
    InputOutput.<String>println("Executing Dump Hummingbird 2.0 workflow component");
    Object _get = ctx.get(IWorkflowSlots.MODEL_SLOT_NAME);
    final List<EObject> modelObjects = ((List<EObject>) _get);
    boolean _or = false;
    boolean _equals = Objects.equal(modelObjects, null);
    if (_equals) {
      _or = true;
    } else {
      boolean _isEmpty = modelObjects.isEmpty();
      _or = _isEmpty;
    }
    if (_or) {
      InputOutput.<String>println("Model slot is empty, nothing to do!");
      return;
    }
    for (final EObject modelObject : modelObjects) {
      {
        final TreeIterator<EObject> eAllContents = modelObject.eAllContents();
        while (eAllContents.hasNext()) {
          {
            final EObject element = eAllContents.next();
            if ((element instanceof Identifiable)) {
              String _name = ((Identifiable)element).getName();
              String _plus = ("=> " + _name);
              InputOutput.<String>println(_plus);
            }
          }
        }
      }
    }
    InputOutput.<String>println("Done!");
  }
}
