/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.eclipse.sphinx.examples.hummingbird20.workflows.hello;

import com.google.common.base.Objects;
import java.util.Iterator;
import java.util.List;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.mwe.core.WorkflowContext;
import org.eclipse.emf.mwe.core.issues.Issues;
import org.eclipse.emf.mwe.core.monitor.ProgressMonitor;
import org.eclipse.sphinx.emf.mwe.dynamic.IWorkflowSlots;
import org.eclipse.sphinx.emf.mwe.dynamic.components.AbstractModelWorkflowComponent;
import org.eclipse.sphinx.examples.hummingbird20.common.Identifiable;
import org.eclipse.xtext.xbase.lib.InputOutput;

@SuppressWarnings("all")
public class HelloHummingbird20WorkflowComponent extends AbstractModelWorkflowComponent {
  protected void invokeInternal(final WorkflowContext ctx, final ProgressMonitor monitor, final Issues issues) {
    InputOutput.<String>println("Executing Hello Hummingbird 2.0 workflow component");
    Object _get = ctx.get(IWorkflowSlots.MODEL_SLOT_NAME);
    final List<EObject> modelObjects = ((List<EObject>) _get);
    boolean _or = false;
    boolean _equals = Objects.equal(modelObjects, null);
    if (_equals) {
      _or = true;
    } else {
      boolean _isEmpty = modelObjects.isEmpty();
      _or = _isEmpty;
    }
    if (_or) {
      InputOutput.<String>println("Model slot is empty, nothing to do!");
      return;
    }
    String msg = "Model slot contains: ";
    final Iterator<EObject> iter = modelObjects.iterator();
    while (iter.hasNext()) {
      {
        final EObject modelObject = iter.next();
        if ((modelObject instanceof Identifiable)) {
          String _msg = msg;
          String _xifexpression = null;
          boolean _and = false;
          String _name = ((Identifiable)modelObject).getName();
          boolean _notEquals = (!Objects.equal(_name, null));
          if (!_notEquals) {
            _and = false;
          } else {
            String _name_1 = ((Identifiable)modelObject).getName();
            boolean _isEmpty_1 = _name_1.isEmpty();
            boolean _not = (!_isEmpty_1);
            _and = _not;
          }
          if (_and) {
            _xifexpression = ((Identifiable)modelObject).getName();
          } else {
            EClass _eClass = ((Identifiable)modelObject).eClass();
            String _name_2 = _eClass.getName();
            _xifexpression = ("Unnamed " + _name_2);
          }
          msg = (_msg + _xifexpression);
        } else {
          String _msg_1 = msg;
          String _string = modelObject.toString();
          msg = (_msg_1 + _string);
        }
        boolean _hasNext = iter.hasNext();
        if (_hasNext) {
          String _msg_2 = msg;
          msg = (_msg_2 + ", ");
        }
      }
    }
    InputOutput.<String>println(msg);
    InputOutput.<String>println("Done!");
  }
}
